part of mila;

typedef bool _Checker(DeclarationMirror mirror);

class _ClassMirrorUtil {
  final ClassMirror mirror;

  _ClassMirrorUtil(this.mirror);

  Map<Symbol, DeclarationMirror> _getSpecificDeclaration(_Checker checker) {
    var dmList = declarations.values.where(checker),
        dmMap = new Map.fromIterable(dmList,
            key: (dMirror) => dMirror.simpleName,
            value: (dMirror) => dMirror);

    return dmMap;
  }

  Map<Symbol, DeclarationMirror> get declarations => mirror.declarations;

  Map<Symbol, VariableMirror> get variables {

    bool isVariable(DeclarationMirror dMirror) =>
        !dMirror.isPrivate && dMirror is VariableMirror;

    return _getSpecificDeclaration(isVariable);
  }

  Map<Symbol, MethodMirror> get getter {
    bool isGetter(DeclarationMirror dMirror) =>
        !dMirror.isPrivate && dMirror is MethodMirror && dMirror.isGetter;

    return _getSpecificDeclaration(isGetter);
  }

  Map<Symbol, MethodMirror> get setter {
    bool isSetter(DeclarationMirror dMirror) =>
        !dMirror.isPrivate && dMirror is MethodMirror && dMirror.isSetter;

    return _getSpecificDeclaration(isSetter);
  }

  Map<Symbol, MethodMirror> get methods {
    bool isMethod(DeclarationMirror dMirror) =>
        !dMirror.isPrivate && dMirror is MethodMirror &&
        dMirror.isRegularMethod && !dMirror.isOperator;

    return _getSpecificDeclaration(isMethod);
  }

  String get name => MirrorSystem.getName(mirror.simpleName);
}