part of mila;

class _MapFactory {
  final Model model;

  _MapFactory(this.model);

  Map create() {
    var container = {},
        mirror = reflect(model),
        classMirror = mirror.type,
        mirrorUtil = new _ModelMirrorUtil(classMirror),
        fieldDeclaration = mirrorUtil.fields;

    fieldDeclaration.keys.forEach((symbol) {
      var key = MirrorSystem.getName(symbol),
          hasModel = mirrorUtil.hasModel(symbol),
          value = mirror.getField(symbol).reflectee;

      if (!hasModel) {
        container[key] = value;
      } else {
        if (value != null) {
          container[key] = _traverseField(value);
        } else {
          container[key] = value;
        }
      }
    });

    return container;
  }


  _traverseField(data) {
    if (data is Iterable) {
      return data.map(_traverseField).toList(growable: false);
    } else if (data is Map) {
      var keys = data.keys,
          values = data.values.map(_traverseField);

      return new Map.fromIterables(keys, values);
    } else {
      return data.toMap();
    }
  }
}
