part of mila;

class _TypeChecker {
  final data;
  final List<ClassMirror> generics;

  _TypeChecker(this.data, this.generics);

  void check() => _typeChecker(_getDataRepresentation());

  void _typeChecker(List dataRepr) {
    generics.removeLast();
    var instances = generics.map((cm) =>
          cm.newInstance(const Symbol(''), []).reflectee),
        length = instances.length;

    for (var i = 0; i < length; i++) {
      var instance = instances.elementAt(i),
          data = dataRepr[i];

      if (instance is List) {
        instance.add(data);
      } else if (instance is Map) {
        instance.addAll({'foo' : data});
      }
    }
  }

  List _getDataRepresentation() {
    var current,
        container = [];

    if (data is List) {
      current = new List.from(data);
    } else if (data is Map) {
      current = new List.from(data.values);
    }

    while (current.isNotEmpty) {
      container.add(current.first);

      if (current.last is List) {
        current = new List.from(current.last);
      } else if (current.last is Map) {
        current = new List.from(current.last.values);
      } else {
        return container;
      }
    }
  }
}
