part of mila;

class _Validator {
  InstanceMirror mirror;
  _ModelMirrorUtil util;

  _Validator(Model model) {
    mirror = reflect(model);
    util = new _ModelMirrorUtil(mirror.type);
  }

  Future validateAll() => Future.wait(util.fields.keys.map(validateOne));

  Future validateOne(Symbol symbol) {
    var c = new Completer(),
        rules = util.getRule(symbol),
        value = mirror.getField(symbol).reflectee,
        generics = util.getGenerics(symbol);

    new Future(() => util.hasGeneric(symbol))
      .then((contain) =>
          contain && (value != null)
          ? new _TypeChecker(value, generics).check() : contain)
      .then((_) => Future.forEach(rules.map((rule) => rule.reflectee),
                                  (rule) => rule.execute(value)))
      .then(c.complete)
      .catchError((error, stackTrace) =>
          c.completeError(error, stackTrace));

    return c.future;
  }
}